<?php
/*
	Back-end / Front-end functions
*/
// load local front-end module config
function loadConfiguration ($multishop_page_uid='')
{
	$query = $GLOBALS['TYPO3_DB']->SELECTquery(
					'*',         // SELECT ...
					'tx_multishop_configuration_values',     // FROM ...
					'page_uid="'.$multishop_page_uid.'"',    // WHERE...
					'',            // GROUP BY...
					'',    // ORDER BY...
					''            // LIMIT ...
	);
	$res = $GLOBALS['TYPO3_DB']->sql(TYPO3_db, $query);
	if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
	{
		while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
		{
			if (isset($row['configuration_value']) and $row['configuration_value'] != '') $ms['LOCAL_MODULES'][$row['configuration_key']]=$row['configuration_value'];
		}	
	}
	// load local front-end module config eof
	// load global front-end module config
	$query = $GLOBALS['TYPO3_DB']->SELECTquery(
					'*',         // SELECT ...
					'tx_multishop_configuration',     // FROM ...
					'',    // WHERE...
					'',            // GROUP BY...
					'',    // ORDER BY...
					''            // LIMIT ...
	);
	$res = $GLOBALS['TYPO3_DB']->sql(TYPO3_db, $query);
	if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
	{
		while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
		{
			if (isset($row['configuration_value'])) $ms['MODULES']['GLOBAL_MODULES'][$row['configuration_key']]=$row['configuration_value'];
		}	
	}
	// load global front-end module config eof
	// merge global with local front-end module config
	foreach ($ms['MODULES']['GLOBAL_MODULES'] as $key => $value)
	{
		if (isset($ms['LOCAL_MODULES'][$key]))	$ms['MODULES'][$key]=$ms['LOCAL_MODULES'][$key];
		else												$ms['MODULES'][$key]=$value;
	}
	// merge global with local front-end module config eof	
	$key='AFFILIATE_SHOP';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="delete from `tx_multishop_configuration` where configuration_key='".$key."';";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
		$str="delete from `tx_multishop_configuration` where configuration_title='iDEAL Test Stage';";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
		$str="replace INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(3, 'Misc', '', NULL, 1);";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);	
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Affiliate Shop', '".$key."', '0', 'This module enables the webshop as affiliate shop (hiding the order/basket system).', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='COUNTRY_ISO_NR';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Webshop Country ISO Number', '".$key."', '0', 'The country where the webstore is located. Used to determine the local VAT classes.', 3, NULL, NULL, now(), NULL, 'tep_country_select_option(');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);			
	}
	$key='SHOW_INNER_FOOTER_NAV';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show the footer navigation in the middle content', '".$key."', '0', 'This module enables the inner footer navigation.', 1, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='STORE_NAME';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Store Name', '".$key."', '', 'The name of the store.', 3, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='STORE_EMAIL';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Store E-mail', '".$key."', '', 'The e-mail address of the store owner.', 3, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	// update fixed
	$str="select `key` from tx_multishop_configuration ";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_configuration` CHANGE `key` `configuration_key` VARCHAR( 64 ) NOT NULL DEFAULT ''";
		$qry=mysql_query($str);
	}
	$str="select `value` from tx_multishop_configuration ";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_configuration` CHANGE `value` `configuration_value` VARCHAR( 64 ) NOT NULL DEFAULT ''";
		$qry=mysql_query($str);
	}
	$str="select `title` from tx_multishop_configuration ";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_configuration` CHANGE `title` `configuration_title` VARCHAR( 64 ) NOT NULL DEFAULT ''";
		$qry=mysql_query($str);
	}
	$str="select `title` from tx_multishop_configuration_group ";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_configuration_group` CHANGE `title` `configuration_title` VARCHAR( 64 ) NOT NULL DEFAULT ''";
		$qry=mysql_query($str);
	}	
	$str="select products_tax_class_id from tx_multishop_products";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_products` CHANGE `products_tax_class_id` `tax_id` INT( 5 ) NOT NULL DEFAULT '0'";
		$qry=mysql_query($str);
	}
	$str="select page_id from tx_multishop_cms";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_cms` CHANGE `page_id` `page_uid` INT(11) NOT NULL DEFAULT '0'";
		$qry=mysql_query($str);
	}
	$str="select date_added from tx_multishop_cms";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_cms` CHANGE `date_added` `crdate` INT(11) NOT NULL DEFAULT '0'";
		$qry=mysql_query($str);
	}
	$str="select date_added from tx_multishop_orders_status_history";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders_status_history` CHANGE `date_added` `crdate` INT(11) NOT NULL DEFAULT '0'";
		$qry=mysql_query($str);
	}
	$str="select payed from tx_multishop_orders";
	$qry=mysql_query($str);
	if (!$qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders` ADD `payed` TINYINT( 1 ) NOT NULL ";
		$qry=mysql_query($str);
		$str="ALTER TABLE `tx_multishop_orders` ADD INDEX ( `payed` )";
		$qry=mysql_query($str);
	}
	
	$str="select * from tx_multishop_shipping_countries";
	$qry=mysql_query($str);
	if (!$qry)
	{	
		$str="CREATE TABLE `tx_multishop_shipping_countries` (
	  `id` int(11) NOT NULL auto_increment,
	  `page_uid` int(11) NOT NULL,
	  `cn_iso_nr` int(11) NOT NULL,
	  PRIMARY KEY  (`id`),
	  UNIQUE KEY `cn_iso_nr` (`cn_iso_nr`,`page_uid`)
	) ENGINE=MyISAM  ;";
		$qry=mysql_query($str);
	}
	$str="select * from tx_multishop_configuration_group where id='2'";
	$qry=mysql_query($str);
	if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
	{
		$row = mysql_fetch_assoc($qry);
		if ($row['configuration_title']=='Product Listing')
		{
			$str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Image Settings' WHERE `id` =2;";
			$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
		}	
		elseif ($row['configuration_title']=='Image Size Settings')
		{
			$str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Image Settings' WHERE `id` =2;";
			$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
		}			
	}	
	$str="select * from tx_multishop_configuration_group where id='3'";
	$qry=mysql_query($str);
	if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
	{
		$row = mysql_fetch_assoc($qry);
		if ($row['configuration_title']=='Misc')
		{
			$str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Webshop Settings' WHERE `id` =3;";
			$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
		}	
	}
	$str="select * from tx_multishop_configuration where configuration_title='Store Name' and group_id='1'";
	$qry=mysql_query($str);
	if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
	{
		$str="UPDATE `tx_multishop_configuration` SET `group_id` =3 WHERE configuration_title='Store Name';";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
// 12 july 2010
	$str="select `billing_phone` from tx_multishop_orders ";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders` CHANGE `billing_phone` `billing_telephone` VARCHAR( 150 ) NULL DEFAULT NULL ";
		$qry=mysql_query($str);
	}	
	$str="select `delivery_phone` from tx_multishop_orders ";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders` CHANGE `delivery_phone` `delivery_telephone` VARCHAR( 150 ) NULL DEFAULT NULL ";
		$qry=mysql_query($str);
	}		
	$str="select `billing_gender` from tx_multishop_orders ";
	$qry=mysql_query($str);
	if (!$qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders` ADD `billing_gender` CHAR( 1 ) NULL ";
		$qry=mysql_query($str);
	}		
	$str="select `billing_birthday` from tx_multishop_orders ";
	$qry=mysql_query($str);
	if (!$qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders` ADD `billing_birthday` int( 11 ) NULL ";
		$qry=mysql_query($str);
	}		
	$str="select `billing_email` from tx_multishop_orders ";
	$qry=mysql_query($str);
	if (!$qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders` ADD `billing_email` varchar( 254 ) NULL ";
		$qry=mysql_query($str);
	}		
	$str="select `delivery_gender` from tx_multishop_orders ";
	$qry=mysql_query($str);
	if (!$qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders` ADD `delivery_gender` CHAR( 1 ) NULL ";
		$qry=mysql_query($str);
	}		
	$str="select `delivery_email` from tx_multishop_orders ";
	$qry=mysql_query($str);
	if (!$qry)
	{	
		$str="ALTER TABLE `tx_multishop_orders` ADD `delivery_email` varchar( 254 ) NULL 	";
		$qry=mysql_query($str);
	}		

// 12 july eof	
	$width='normal';
	$value="176x140";
	$key='CATEGORY_IMAGE_SIZE_'.strtoupper($width);
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Category image size', '".$key."', '".$value."', 'The maximum image size in pixels for the category image folder.', 2, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	
	}
	$width=50;
	$value="50x50";
	$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$width=100;
	$value="175x123";
	$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$width=200;
	$value="140x150";
	$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$width=300;
	$value="350x300";
	$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$width='enlarged';
	$value="600x400";
	$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	
	// meta
	$key='META_TITLE';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Title', '".$key."', 'Webshop Title', 'The title of the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='META_DESCRIPTION';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Description', '".$key."', 'Description of the webshop.', 'The description of the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='META_KEYWORDS';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Keywords', '".$key."', 'keyword1, keyword2', 'The search words that are related to the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$str="select * from tx_multishop_configuration_group where id='4'";
	$qry=mysql_query($str);
	if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
	{
		$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(4, 'Webshop Plugins', '', NULL, 1);";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='GOOGLE_ANALYTICS_ACCOUNT';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Google Analytics Account', '".$key."', 'UA-16775241-1', 'Google Analytics is the enterprise-class web analytics solution that gives you rich insights into your website traffic and marketing effectiveness.', 4, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='ADDTHIS_ACCOUNT';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Addthis Account', '".$key."', 'typo3multishop', 'Add a Addthis button to your webshop. Addthis.com makes sharing your website urls easy.', 4, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='GOOGLE_ADWORDS_CONVERSION_CODE';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Google Adwords Conversion Code', '".$key."', '', 'Add a Google Adwords Conversion Code to the thank you page of the webshop. This makes it possible to calculate the success-ratio of your Google Adwords campaign.', 4, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='PRODUCT_IMAGE_WATERMARK_TEXT';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Text', '".$key."', '', 'Add a watermark to enlarged product images. Example value: typo3multishop.com', 2, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}	
	$key='PRODUCT_IMAGE_WATERMARK_FONT_SIZE';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Font-size', '".$key."', '16', 'Specify the font-size (in pt) of the watermark. Example value: 16', 2, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='PRODUCT_IMAGE_WATERMARK_POSITION';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Position', '".$key."', 'south-east', 'Choose the position of the watermark.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''north-east'', ''south-east'',''south-west'',''north-west''),');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);
	}
	$key='PRODUCT_IMAGE_SHAPED_CORNERS';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Shaped Corners', '".$key."', '0', 'Adds shaped corners to every thumbnailed product image.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);
	}	
	$key='CATEGORY_IMAGE_SHAPED_CORNERS';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Category Image Shaped Corners', '".$key."', '0', 'Adds shaped corners to every category image.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);
	}		
	// ok now we going to convert the table schemes
	// products description
	$from	='products_title_seo';
	$to	='products_meta_title';
	$str="select ".$from." from tx_multishop_products_description";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
		$qry=mysql_query($str);
	}
	$from	='meta_description';
	$to	='products_meta_description';
	$str="select ".$from." from tx_multishop_products_description";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
		$qry=mysql_query($str);
	}
	$from	='products_keywords';
	$to	='products_meta_keywords';
	$str="select ".$from." from tx_multishop_products_description";
	$qry=mysql_query($str);
	if ($qry)
	{	
		$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
		$qry=mysql_query($str);
	}
	$key='PRODUCTS_LISTING_LIMIT';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Limiting', '".$key."', '18', 'The total number of displayed products per page.', 3, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='CHECKOUT_TYPE';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Checkout Type', '".$key."', 'multistep', 'Choose which checkout process should be used (ie: multistep).', 3, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='SHOW_PRICES_WITH_AND_WITHOUT_VAT';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show product prices with and without VAT', '".$key."', '0', 'If products contain VAT the price including and excluding VAT will be shown.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}	
	$str="select * from tx_multishop_configuration_group where id='5'";
	$qry=mysql_query($str);
	if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
	{
		$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(5, 'Categories Listing', '', NULL, 1);";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$str="select * from tx_multishop_configuration_group where id='6'";
	$qry=mysql_query($str);
	if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
	{
		$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(6, 'Products Listing', '', NULL, 1);";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='CATEGORIES_LISTING_TYPE';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Categories Listing Type', '".$key."', 'grid', 'The lay-out type for displaying the categories listing.', 5, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='PRODUCTS_LISTING_TYPE';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Type', '".$key."', 'grid', 'The lay-out type for displaying the products listing.', 6, NULL, NULL, now(), NULL, '');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$str="select * from tx_multishop_configuration_group where id='7'";
	$qry=mysql_query($str);
	if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
	{
		$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(7, 'Products Detail Page', '', NULL, 1);";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$key='PRODUCTS_DETAIL_PAGE_PAGINATION';
	if (!isset($ms['MODULES']['GLOBAL_MODULES'][$key]))
	{
		$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Pagination', '".$key."', '0', 'Show\'s a button Previous and Next on the products detail page to go to the next or previous product within the same category.', 7, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}
	$sql = "describe tx_multishop_shipping_countries_to_zones";
	$qry = mysql_query($sql);
	while ($rs = mysql_fetch_assoc($qry))
	{
		if ($rs['Field'] == 'cn_iso_nr') 
		{
			if ($rs['Type'] =='int(4)')
			{
				$str="ALTER TABLE `tx_multishop_shipping_countries_to_zones` CHANGE `cn_iso_nr` `cn_iso_nr` INT( 11 ) NULL DEFAULT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);	
				break;
			}
		}
	}
	$str="SELECT * from tx_multishop_import_jobs limit 1";
	if (!$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str))
	{	
		$str="CREATE TABLE `tx_multishop_import_jobs` (
		`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`name` VARCHAR( 254 ) NOT NULL ,
		`period` INT( 11 ) NOT NULL ,
		`last_run` INT( 11 ) NOT NULL ,
		`data` TEXT NOT NULL ,
		`status` TINYINT( 1 ) NOT NULL ,
		`page_uid` INT( 11 ) NOT NULL,
		`categories_id` INT( 5 ) NULL,
		INDEX ( `last_run` , `status` , `page_uid`,`categories_id` ) 
		) ;";
		$qry=$GLOBALS['TYPO3_DB']->sql(TYPO3_db,$str);		
	}	
	// load default vars for upgrade purposes eof
	return $ms['MODULES'];
}
function resizeCategoryImage ($original_path,$filename,$module_path) 
{
	global $ms;
	$maxwidth=$ms['category_image_formats']['normal']['width'];
	$maxheight=$ms['category_image_formats']['normal']['height'];
	$target=$_SERVER['DOCUMENT_ROOT'].'/'.$ms['image_paths']['categories']['normal'].'/'.$filename;
	copy($original_path,$target);																					
	exec($GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'mogrify -quality 90 -strip -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'"');
	if ($ms['MODULES']['CATEGORY_IMAGE_SHAPED_CORNERS'])
	{
		$line1=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthWest '.$module_path.'scripts/includes/images/curves/lb.png "'.$target .'" "'.$target .'"';
		$line2=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthEast '.$module_path.'scripts/includes/images/curves/rb.png "'.$target .'" "'.$target .'"';
		$line3=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthWest '.$module_path.'scripts/includes/images/curves/lo.png "'.$target .'" "'.$target .'"';
		$line4=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthEast '.$module_path.'scripts/includes/images/curves/ro.png "'.$target .'" "'.$target .'"';
		exec($line1);
		exec($line2);
		exec($line3);
		exec($line4);
	}
	return $filename;
}
function resizeProductImage ($original_path,$filename,$module_path) 
{
	global $ms;
	$target=$_SERVER['DOCUMENT_ROOT'].'/'.$ms['image_paths']['products']['300'].'/'.$filename;
	copy($original_path,$target);
	// 300 thumbnail settings
	$maxwidth=$ms['product_image_formats'][300]['width'];
	$maxheight=$ms['product_image_formats'][300]['height'];
	exec($GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'mogrify -quality 90 -strip -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'"');
	if ($ms['MODULES']['PRODUCT_IMAGE_SHAPED_CORNERS'])
	{
		$line1=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthWest '.$module_path.'scripts/includes/images/curves/lb.png "'.$target .'" "'.$target .'"';
		$line2=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthEast '.$module_path.'scripts/includes/images/curves/rb.png "'.$target .'" "'.$target .'"';
		$line3=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthWest '.$module_path.'scripts/includes/images/curves/lo.png "'.$target .'" "'.$target .'"';
		$line4=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthEast '.$module_path.'scripts/includes/images/curves/ro.png "'.$target .'" "'.$target .'"';
		exec($line1);
		exec($line2);
		exec($line3);
		exec($line4);
	}	
	$target=$_SERVER['DOCUMENT_ROOT'].'/'.$ms['image_paths']['products']['200'].'/'.$filename;				
	copy($original_path,$target);
	// 200 thumbnail settings
	$maxwidth=$ms['product_image_formats'][200]['width'];
	$maxheight=$ms['product_image_formats'][200]['height'];
	exec($GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'mogrify -quality 90 -strip -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'"');
	if ($ms['MODULES']['PRODUCT_IMAGE_SHAPED_CORNERS'])
	{
		$line1=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthWest '.$module_path.'scripts/includes/images/curves/lb.png "'.$target .'" "'.$target .'"';
		$line2=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthEast '.$module_path.'scripts/includes/images/curves/rb.png "'.$target .'" "'.$target .'"';
		$line3=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthWest '.$module_path.'scripts/includes/images/curves/lo.png "'.$target .'" "'.$target .'"';
		$line4=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthEast '.$module_path.'scripts/includes/images/curves/ro.png "'.$target .'" "'.$target .'"';
		exec($line1);
		exec($line2);
		exec($line3);
		exec($line4);
	}	
	$target=$_SERVER['DOCUMENT_ROOT'].'/'.$ms['image_paths']['products']['100'].'/'.$filename;				
	copy($original_path,$target);
	// 100 thumbnail settings
	$maxwidth=$ms['product_image_formats'][100]['width'];
	$maxheight=$ms['product_image_formats'][100]['height'];
	exec($GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'mogrify -quality 90 -strip -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'"');	
	$target=$_SERVER['DOCUMENT_ROOT'].'/'.$ms['image_paths']['products']['50'].'/'.$filename;				
	copy($original_path,$target);
	// 50 thumbnail settings
	$maxwidth=$ms['product_image_formats'][50]['width'];
	$maxheight=$ms['product_image_formats'][50]['height'];
	exec($GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'mogrify -quality 90 -strip -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'"');	
	$target=$_SERVER['DOCUMENT_ROOT'].'/'.$ms['image_paths']['products']['normal'].'/'.$filename;				
	copy($original_path,$target);
	// normal thumbnail settings
	$maxwidth=$ms['product_image_formats']['enlarged']['width'];
	$maxheight=$ms['product_image_formats']['enlarged']['height'];
	exec($GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'mogrify -quality 90 -strip -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'"');
	$newsize=@getimagesize($target);
	if (is_numeric($ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_SIZE']) && $ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT'] && ($newsize[0] > '150' && $newsize[1] > 30))
	{
		$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT']=strtoupper($ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT']);
		$tmppath=$_SERVER['DOCUMENT_ROOT'].'/uploads/tx_multishop/tmp';
		switch ($ms['MODULES']['PRODUCT_IMAGE_WATERMARK_POSITION'])
		{
			case 'north-east':
			$pos_x=($newsize[0]-160);
			$pos_y=(25);
			break;				
			case 'south-east':
			$pos_x=($newsize[0]-160);
			$pos_y=($newsize[1]-5);
			break;	
			case 'south-west':
			$pos_x='2';
			$pos_y=($newsize[1]-5);
			break;
			case 'north-west':
			$pos_x='2';
			$pos_y=(25);
			break;			
		}
		$line1='convert -size '.$newsize[0].'x'.$newsize[1].' xc:black -font "'.$module_path.'scripts/includes/images/nasaliza.ttf" -pointsize '.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_SIZE'].' -fill white -draw "text '.$pos_x.','.$pos_y.' \''.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT'].'\'" -shade 140x60  "'.$tmppath.'/beveled_'.$savenametest.'.jpg"';
		$line2='convert -size '.$newsize[0].'x'.$newsize[1].' xc:black -font "'.$module_path.'scripts/includes/images/nasaliza.ttf" -pointsize '.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_SIZE'].' -fill white -draw "text '.$pos_x.','.$pos_y.' \''.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT'].'\'" -shade 140x90  -negate -normalize  "'.$tmppath.'/beveled_mask_'.$savenametest.'.jpg"';
		$line3='composite -compose CopyOpacity   "'.$tmppath.'/beveled_mask_'.$savenametest.'.jpg'.'" "'.$tmppath.'/beveled_'.$savenametest.'.jpg'.'" "'.$tmppath.'/beveled_trans_'.$savenametest.'.png"';
		$line4='composite -quality 75 "'.$tmppath.'/beveled_trans_'.$savenametest.'.png" "'.$target .'" "'.$target.'"';
		exec($line1);
		exec($line2);
		exec($line3);
		exec($line4);
		@unlink($tmppath.'/beveled_'.$savenametest.'.jpg');
		@unlink($tmppath.'/beveled_mask_'.$savenametest.'.jpg');
		@unlink($tmppath.'/beveled_trans_'.$savenametest.'.png');
	}	
	return $filename;
} 
function countProducts ($page_uid)
{
	$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_products','page_uid=\''.$page_uid.'\'','');		
	$row=$data[0];
	if (!isset($row['total'])) $row['total']=0;
	return $row['total'];
}
function countOrders ($page_uid)
{
	$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_orders','page_uid=\''.$page_uid.'\'','');		
	$row=$data[0];
	if (!isset($row['total'])) $row['total']=0;
	return $row['total'];
}
function countCategories ($page_uid)
{
	$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_categories','page_uid=\''.$page_uid.'\'','');		
	$row=$data[0];
	if (!isset($row['total'])) $row['total']=0;
	return $row['total'];
}
function countManufacturers ($page_uid)
{
	$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_manufacturers','page_uid=\''.$page_uid.'\'','');		
	$row=$data[0];
	if (!isset($row['total'])) $row['total']=0;
	return $row['total'];
}
function countImportJobs ($page_uid)
{
	$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_import_jobs','page_uid=\''.$page_uid.'\'','');		
	$row=$data[0];
	if (!isset($row['total'])) $row['total']=0;
	return $row['total'];
}
function deleteProductImage ($file_name)
{
	global $ms;	
	foreach ($ms['image_paths']['products'] as $key => $value)
	{
		$path=$_SERVER['DOCUMENT_ROOT'].'/'.$value.'/'.$file_name;
		if (file_exists($path)) exec("rm ".$path);
	}						
}
function deleteCategoryImage ($file_name)
{
	global $ms;	
	foreach ($ms['image_paths']['categories'] as $key => $value)
	{
		$path=$_SERVER['DOCUMENT_ROOT'].'/'.$value.'/'.$file_name;
		if (file_exists($path)) exec("rm ".$path);
	}						
}
/*
Some PHP compilations doesnt have the exif_imagetype function. In that case we provide our own alternative
*/
if (!function_exists('exif_imagetype'))
{
	function exif_imagetype ($filename)
	{
		if ((list($width,$height,$type,$attr) = getimagesize($filename)) !== false) return $type;
		return false;
	}
} 
$ms['image_paths']['products']['50']				='uploads/tx_multishop/images/products/50';
$ms['image_paths']['products']['100']				='uploads/tx_multishop/images/products/100';
$ms['image_paths']['products']['200']				='uploads/tx_multishop/images/products/200';
$ms['image_paths']['products']['300']				='uploads/tx_multishop/images/products/300';
$ms['image_paths']['products']['original']		='uploads/tx_multishop/images/products/original';
$ms['image_paths']['products']['normal']			='uploads/tx_multishop/images/products/normal';
$ms['image_paths']['categories']['original']		='uploads/tx_multishop/images/categories/original';
$ms['image_paths']['categories']['normal']		='uploads/tx_multishop/images/categories/normal';
$ms['image_paths']['manufacturers']['original']	='uploads/tx_multishop/images/manufacturers/original';
$ms['image_paths']['manufacturers']['normal']	='uploads/tx_multishop/images/manufacturers/normal';
?>